unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls,
  {$ifdef Win32}
  Windows,
  {$endif}
  ImagingTypes,
  ImagingFormats,
  Imaging,
  ImagingClasses,
  ImagingComponents,
  ImagingCanvases,
  ImagingUtility;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnJPG: TButton;
    Image: TImage;
    Panel1: TPanel;
    procedure btnJPGClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FBitmap: TImagingBitmap;
    FImage: TSingleImage;

  public
    { public declarations }
    s: LongInt;
    gbuff: Pointer;

  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FImage := TSingleImage.Create;
  FBitmap := TImagingBitmap.Create;
  Image.Picture.Graphic := FBitmap;
end;

procedure TForm1.btnJPGClick(Sender: TObject);
begin
  FImage.LoadFromFile('test.jpg');
  Image.Picture.Graphic.Assign(FImage);
  s := FImage.Size;
  GetMem(gbuff, s);
  {$ifdef Linux}
  Move(FImage.Bits, gbuff, s);
  {$endif}
  {$ifdef Win32}
  CopyMemory(gbuff, FImage.Bits, s);
  {$endif}
end;

initialization
  {$I Unit1.lrs}

end.

